## giada-0.18.2-1.src.tar.gz

=== CMakeLists.txt ===
# ------------------------------------------------------------------------------
# Preliminary setup
# ------------------------------------------------------------------------------

cmake_minimum_required(VERSION 3.12)

# CMAKE_OSX_DEPLOYMENT_TARGET should be set prior to the first project() or
# enable_language() command invocation because it may influence configuration
# of the toolchain and flags.
# Also, see https://stackoverflow.com/questions/34208360/cmake-seems-to-ignore-cmake-osx-deployment-target

if(CMAKE_SYSTEM_NAME STREQUAL "Darwin")
	set(CMAKE_OSX_DEPLOYMENT_TARGET "10.14" CACHE STRING "Minimum OS X deployment version")
endif()

# ------------------------------------------------------------------------------
# Project
# ------------------------------------------------------------------------------

project(giada LANGUAGES CXX)

# ------------------------------------------------------------------------------
# Lists definition
#
# SOURCES - contains the source files
# PREPROCESSOR_DEFS - preprocessor definitions
# INCLUDE_DIRS - include directories (e.g. -I)
# COMPILER_OPTIONS - additional flags for the compiler
# LIBRARIES - external dependencies to link
# COMPILER_FEATURES - e.g. C++17
# TARGET_PROPERTIES - additional properties for the target 'giada'.
# ------------------------------------------------------------------------------

list(APPEND SOURCES
	src/main.cpp
	src/core/worker.cpp
	src/core/eventDispatcher.cpp
	src/core/midiDispatcher.cpp
	src/core/midiMapConf.cpp
	src/core/midiEvent.cpp
	src/core/quantizer.cpp
	src/core/conf.cpp
	src/core/kernelAudio.cpp
	src/core/jackTransport.cpp
	src/core/mixerHandler.cpp
	src/core/sequencer.cpp
	src/core/metronome.cpp
	src/core/init.cpp
	src/core/wave.cpp
	src/core/waveFx.cpp
	src/core/kernelMidi.cpp
	src/core/graphics.cpp
	src/core/patch.cpp
	src/core/recorderHandler.cpp
	src/core/recorder.cpp
	src/core/mixer.cpp
	src/core/clock.cpp
	src/core/sync.cpp
	src/core/waveManager.cpp
	src/core/recManager.cpp
	src/core/midiLearnParam.cpp
	src/core/resampler.cpp
	src/core/plugins/pluginHost.cpp
	src/core/plugins/pluginManager.cpp
	src/core/plugins/plugin.cpp
	src/core/plugins/pluginState.cpp
	src/core/channels/sampleActionRecorder.cpp
	src/core/channels/midiActionRecorder.cpp
	src/core/channels/waveReader.cpp
	src/core/channels/midiController.cpp
	src/core/channels/sampleReactor.cpp
	src/core/channels/sampleAdvancer.cpp
	src/core/channels/samplePlayer.cpp
	src/core/channels/audioReceiver.cpp
	src/core/channels/midiLighter.cpp
	src/core/channels/midiLearner.cpp
	src/core/channels/midiSender.cpp
	src/core/channels/midiReceiver.cpp
	src/core/channels/channel.cpp
	src/core/channels/channelManager.cpp
	src/core/model/model.cpp
	src/core/model/storage.cpp
	src/core/idManager.cpp
	src/glue/events.cpp
	src/glue/main.cpp
	src/glue/io.cpp
	src/glue/storage.cpp
	src/glue/channel.cpp
	src/glue/plugin.cpp
	src/glue/recorder.cpp
	src/glue/sampleEditor.cpp
	src/glue/actionEditor.cpp
	src/glue/config.cpp
	src/gui/dialogs/window.cpp
	src/gui/dispatcher.cpp
	src/gui/updater.cpp
	src/gui/model.cpp
	src/gui/drawing.cpp
	src/gui/dialogs/keyGrabber.cpp
	src/gui/dialogs/about.cpp
	src/gui/dialogs/mainWindow.cpp
	src/gui/dialogs/beatsInput.cpp
	src/gui/dialogs/warnings.cpp
	src/gui/dialogs/bpmInput.cpp
	src/gui/dialogs/channelNameInput.cpp
	src/gui/dialogs/config.cpp
	src/gui/dialogs/pluginList.cpp
	src/gui/dialogs/pluginWindow.cpp
	src/gui/dialogs/sampleEditor.cpp
	src/gui/dialogs/pluginWindowGUI.cpp
	src/gui/dialogs/pluginChooser.cpp
	src/gui/dialogs/actionEditor/baseActionEditor.cpp
	src/gui/dialogs/actionEditor/sampleActionEditor.cpp
	src/gui/dialogs/actionEditor/midiActionEditor.cpp
	src/gui/dialogs/browser/browserBase.cpp
	src/gui/dialogs/browser/browserDir.cpp
	src/gui/dialogs/browser/browserLoad.cpp
	src/gui/dialogs/browser/browserSave.cpp
	src/gui/dialogs/midiIO/midiOutputBase.cpp
	src/gui/dialogs/midiIO/midiOutputSampleCh.cpp
	src/gui/dialogs/midiIO/midiOutputMidiCh.cpp
	src/gui/dialogs/midiIO/midiInputBase.cpp
	src/gui/dialogs/midiIO/midiInputChannel.cpp
	src/gui/dialogs/midiIO/midiInputMaster.cpp
	src/gui/elems/midiIO/midiLearner.cpp
	src/gui/elems/midiIO/midiLearnerPack.cpp
	src/gui/elems/browser.cpp
	src/gui/elems/soundMeter.cpp
	src/gui/elems/plugin/pluginBrowser.cpp
	src/gui/elems/plugin/pluginParameter.cpp
	src/gui/elems/plugin/pluginElement.cpp
	src/gui/elems/sampleEditor/waveform.cpp
	src/gui/elems/sampleEditor/waveTools.cpp
	src/gui/elems/sampleEditor/volumeTool.cpp
	src/gui/elems/sampleEditor/boostTool.cpp
	src/gui/elems/sampleEditor/panTool.cpp
	src/gui/elems/sampleEditor/pitchTool.cpp
	src/gui/elems/sampleEditor/rangeTool.cpp
	src/gui/elems/sampleEditor/shiftTool.cpp
	src/gui/elems/actionEditor/baseActionEditor.cpp
	src/gui/elems/actionEditor/baseAction.cpp
	src/gui/elems/actionEditor/envelopeEditor.cpp
	src/gui/elems/actionEditor/velocityEditor.cpp
	src/gui/elems/actionEditor/envelopePoint.cpp
	src/gui/elems/actionEditor/pianoRoll.cpp
	src/gui/elems/actionEditor/pianoItem.cpp
	src/gui/elems/actionEditor/sampleActionEditor.cpp
	src/gui/elems/actionEditor/sampleAction.cpp
	src/gui/elems/actionEditor/gridTool.cpp
	src/gui/elems/actionEditor/splitScroll.cpp
	src/gui/elems/mainWindow/mainIO.cpp
	src/gui/elems/mainWindow/mainMenu.cpp
	src/gui/elems/mainWindow/mainTimer.cpp
	src/gui/elems/mainWindow/mainTransport.cpp
	src/gui/elems/mainWindow/sequencer.cpp
	src/gui/elems/mainWindow/keyboard/channelMode.cpp
	src/gui/elems/mainWindow/keyboard/channelButton.cpp
	src/gui/elems/mainWindow/keyboard/channelStatus.cpp
	src/gui/elems/mainWindow/keyboard/keyboard.cpp
	src/gui/elems/mainWindow/keyboard/column.cpp
	src/gui/elems/mainWindow/keyboard/sampleChannel.cpp
	src/gui/elems/mainWindow/keyboard/midiChannel.cpp
	src/gui/elems/mainWindow/keyboard/channel.cpp
	src/gui/elems/mainWindow/keyboard/sampleChannelButton.cpp
	src/gui/elems/mainWindow/keyboard/midiChannelButton.cpp
	src/gui/elems/config/tabMisc.cpp
	src/gui/elems/config/tabMidi.cpp
	src/gui/elems/config/tabAudio.cpp
	src/gui/elems/config/tabBehaviors.cpp
	src/gui/elems/config/tabPlugins.cpp
	src/gui/elems/basics/scroll.cpp
	src/gui/elems/basics/pack.cpp
	src/gui/elems/basics/group.cpp
	src/gui/elems/basics/scrollPack.cpp
	src/gui/elems/basics/boxtypes.cpp
	src/gui/elems/basics/statusButton.cpp
	src/gui/elems/basics/button.cpp
	src/gui/elems/basics/resizerBar.cpp
	src/gui/elems/basics/input.cpp
	src/gui/elems/basics/liquidScroll.cpp
	src/gui/elems/basics/choice.cpp
	src/gui/elems/basics/dial.cpp
	src/gui/elems/basics/box.cpp
	src/gui/elems/basics/slider.cpp
	src/gui/elems/basics/progress.cpp
	src/gui/elems/basics/check.cpp
	src/gui/elems/basics/split.cpp
	src/utils/log.cpp
	src/utils/time.cpp
	src/utils/math.cpp
	src/utils/gui.cpp
	src/utils/fs.cpp
	src/utils/ver.cpp
	src/utils/string.cpp
	src/deps/rtaudio/RtAudio.cpp
	src/deps/mcl-audio-buffer/src/audioBuffer.cpp)

list(APPEND PREPROCESSOR_DEFS)
list(APPEND INCLUDE_DIRS
	${CMAKE_SOURCE_DIR}
	${CMAKE_SOURCE_DIR}/src)
list(APPEND COMPILER_OPTIONS)
list(APPEND LIBRARIES)
list(APPEND COMPILER_FEATURES cxx_std_17)
list(APPEND TARGET_PROPERTIES)

# ------------------------------------------------------------------------------
# Detect OS
# ------------------------------------------------------------------------------

if(CMAKE_SYSTEM_NAME STREQUAL "Linux")
	set(OS_LINUX 1)
elseif(CMAKE_SYSTEM_NAME STREQUAL "Windows")
	set(OS_WINDOWS 1)
elseif(CMAKE_SYSTEM_NAME STREQUAL "Darwin")
	set(OS_MACOS 1)
elseif(CMAKE_SYSTEM_NAME STREQUAL "FreeBSD")
	set(OS_FREEBSD 1)
else()
	message(FATAL_ERROR "Unsupported platform '${CMAKE_SYSTEM_NAME}', quitting.")
endif()

# ------------------------------------------------------------------------------
# Compiler warnings
# ------------------------------------------------------------------------------

if(DEFINED OS_WINDOWS)
	list(APPEND COMPILER_OPTIONS /W4)
else()
	list(APPEND COMPILER_OPTIONS -Wall -Wextra -Wpedantic)
endif()

# ------------------------------------------------------------------------------
# Options
# ------------------------------------------------------------------------------

option(WITH_VST2 "Enable VST2 support." OFF)
option(WITH_VST3 "Enable VST3 support." OFF)
option(WITH_TESTS "Include the test suite." OFF)

if(DEFINED OS_LINUX)
	option(WITH_ALSA "Enable ALSA support (Linux only)." ON)
	option(WITH_PULSE "Enable PulseAudio support (Linux only)." ON)
	option(WITH_JACK "Enable JACK support (Linux only)." ON)
endif()

if(WITH_TESTS)
	list(APPEND PREPROCESSOR_DEFS 
		WITH_TESTS
		TEST_RESOURCES_DIR="${CMAKE_SOURCE_DIR}/tests/resources/")
endif()

if(NOT CMAKE_BUILD_TYPE STREQUAL "Debug")
	list(APPEND PREPROCESSOR_DEFS NDEBUG)
endif()

# ------------------------------------------------------------------------------
# Dependencies
# ------------------------------------------------------------------------------

# Threads (system)

find_package(Threads REQUIRED)
list(APPEND LIBRARIES ${Threads_LIBRARY})

# pkg-config/pkgconf, required to find some external dependencies on some
# platforms
find_package(PkgConfig)

# RtMidi

find_package(RtMidi CONFIG)
if (RtMidi_FOUND)
	list(APPEND LIBRARIES RtMidi::rtmidi)
	message("RtMidi library found in " ${RtMidi_DIR})
elseif (PkgConfig_FOUND)
	pkg_check_modules(RtMidi IMPORTED_TARGET rtmidi)
	if (RtMidi_FOUND)
		list(APPEND LIBRARIES PkgConfig::RtMidi)
		message("RtMidi library found")
	endif()
endif()

if (NOT RtMidi_FOUND)
	# Fallback to find_library mode (in case rtmidi is too old). 
	find_library(LIBRARY_RTMIDI NAMES rtmidi)
	list(APPEND LIBRARIES ${LIBRARY_RTMIDI})

	if (NOT LIBRARY_RTMIDI)
		message(FATAL_ERROR "Can't find RtMidi, aborting.")
	endif()

	# RtMidi header path may vary accross OSes, so a fix is needed.
	# TODO - Find a way to avoid this additional step

	find_path(LIBRARY_RTMIDI_INCLUDE_DIR RtMidi.h PATH_SUFFIXES rtmidi)
	list(APPEND INCLUDE_DIRS ${LIBRARY_RTMIDI_INCLUDE_DIR})
	message("RtMidi library found in " ${RtMidi_DIR})
endif()

# FLTK 

set(FLTK_SKIP_FLUID TRUE)  # Don't search for FLTK's fluid
set(FLTK_SKIP_OPENGL TRUE) # Don't search for FLTK's OpenGL
find_package(FLTK CONFIG REQUIRED)
list(APPEND LIBRARIES fltk fltk_gl fltk_forms fltk_images)
message("FLTK library found in " ${FLTK_DIR})

# Libsndfile

find_package(SndFile CONFIG)
if (SndFile_FOUND)
	list(APPEND LIBRARIES SndFile::sndfile)
	message("Libsndfile library found in " ${SndFile_DIR})
elseif(PkgConfig_FOUND)
	pkg_check_modules(SndFile IMPORTED_TARGET sndfile)
	if (SndFile_FOUND)
		list(APPEND LIBRARIES PkgConfig::SndFile)
		message("Libsndfile library found")
	endif()	
endif()

if (NOT SndFile_FOUND)
	# Fallback to find_library mode (in case libsndfile is too old). 
	find_library(LIBRARY_SNDFILE NAMES sndfile libsndfile libsndfile-1)
	
	if (NOT LIBRARY_SNDFILE)
		message(FATAL_ERROR "Can't find libsndfile, aborting.")
	endif()

	list(APPEND LIBRARIES ${LIBRARY_SNDFILE})
	message("Libsndfile library found in " ${LIBRARY_SNDFILE})

	# Find optional dependencies.

	find_library(LIBRARY_FLAC NAMES flac FLAC)
	find_library(LIBRARY_OGG NAMES ogg)
	find_library(LIBRARY_OPUS NAMES opus libopus)
	find_library(LIBRARY_VORBIS NAMES vorbis)
	find_library(LIBRARY_VORBISENC NAMES vorbisenc)

	if(LIBRARY_FLAC)
		list(APPEND LIBRARIES ${LIBRARY_FLAC})
	endif()
	if(LIBRARY_OGG)
		list(APPEND LIBRARIES ${LIBRARY_OGG})
	endif()
	if(LIBRARY_OPUS)
		list(APPEND LIBRARIES ${LIBRARY_OPUS})
	endif()
	if(LIBRARY_VORBIS)
		list(APPEND LIBRARIES ${LIBRARY_VORBIS})
	endif()
	if(LIBRARY_VORBISENC)
		list(APPEND LIBRARIES ${LIBRARY_VORBISENC})
	endif()	
endif()

# Libsamplerate

find_package(SampleRate CONFIG)
if (SampleRate_FOUND)
	list(APPEND LIBRARIES SampleRate::samplerate)
	message("Libsndfile library found in " ${SampleRate_DIR})
else() 
	# Fallback to find_library mode (in case Libsamplerate is too old). 
	find_library(LIBRARY_SAMPLERATE 
	    NAMES samplerate libsamplerate libsamplerate-0 liblibsamplerate-0
	    PATHS ${_VCPKG_ROOT_DIR}/installed/${VCPKG_TARGET_TRIPLET}

=== src/deps/rtaudio/CMakeLists.txt ===
# Set minimum CMake required version for this project.
cmake_minimum_required(VERSION 3.10 FATAL_ERROR)

# Define a C++ project.
project(RtAudio LANGUAGES CXX)

# standards version
set(CMAKE_CXX_STANDARD 11)
set(CMAKE_CXX_STANDARD_REQUIRED ON)
set(CMAKE_CXX_EXTENSIONS OFF)

# Check for Jack (any OS)
find_library(JACK_LIB jack)
find_package(PkgConfig)
pkg_check_modules(jack jack)
if(JACK_LIB OR jack_FOUND)
  set(HAVE_JACK TRUE)
endif()

# Check for Pulse (any OS)
pkg_check_modules(pulse libpulse-simple)

# Check for known non-Linux unix-likes
if (CMAKE_SYSTEM_NAME MATCHES "kNetBSD.*|NetBSD.*")
  message(STATUS "NetBSD detected, using OSS")
  set(xBSD ON)
elseif(UNIX AND NOT APPLE)
  set(LINUX ON)
endif()

# Necessary for Windows
if(MINGW)
  set(CMAKE_WINDOWS_EXPORT_ALL_SYMBOLS ON)
endif()

# Standard CMake options
option(BUILD_SHARED_LIBS "Build as shared library" ON)

if (NOT CMAKE_CONFIGURATION_TYPES AND NOT CMAKE_BUILD_TYPE)
  set_property(CACHE CMAKE_BUILD_TYPE PROPERTY STRINGS "Debug;Release;RelWithDebInfo;MinSizeRel")
endif()
if(WIN32)
  set(CMAKE_DEBUG_POSTFIX d CACHE STRING "Postfix for debug version of library")
endif()

# Build Options
option(RTAUDIO_BUILD_PYTHON "Build PyRtAudio python bindings" OFF)
set(RTAUDIO_TARGETNAME_UNINSTALL "uninstall" CACHE STRING "Name of 'uninstall' build target")

# API Options
option(RTAUDIO_API_DS "Build DirectSound API" OFF)
option(RTAUDIO_API_ASIO "Build ASIO API" OFF)
option(RTAUDIO_API_WASAPI "Build WASAPI API" ${WIN32})
option(RTAUDIO_API_OSS "Build OSS4 API" ${xBSD})
option(RTAUDIO_API_ALSA "Build ALSA API" ${LINUX})
option(RTAUDIO_API_PULSE "Build PulseAudio API" ${pulse_FOUND})
option(RTAUDIO_API_JACK "Build JACK audio server API" ${HAVE_JACK})
option(RTAUDIO_API_CORE "Build CoreAudio API" ${APPLE})

# Check for functions
include(CheckFunctionExists)
check_function_exists(gettimeofday HAVE_GETTIMEOFDAY)
if (HAVE_GETTIMEOFDAY)
    add_definitions(-DHAVE_GETTIMEOFDAY)
endif ()

# Add -Wall if possible
if (CMAKE_COMPILER_IS_GNUCXX)
  set(CMAKE_CXX_FLAGS "${CMAKE_CXX_FLAGS} -Wall")
endif (CMAKE_COMPILER_IS_GNUCXX)

# Add debug flags
if (CMAKE_BUILD_TYPE STREQUAL "Debug")
  add_definitions(-D__RTAUDIO_DEBUG__)
  if (CMAKE_COMPILER_IS_GNUCXX)
    set(CMAKE_CXX_FLAGS "${CMAKE_CXX_FLAGS} -Werror")
  endif (CMAKE_COMPILER_IS_GNUCXX)
endif ()

# Read libtool version info from configure.ac
set(R "m4_define\\(\\[lt_([a-z]+)\\], ([0-9]+)\\)")
file(STRINGS "${CMAKE_CURRENT_SOURCE_DIR}/configure.ac" CONFIGAC
  REGEX ${R})
foreach(_S ${CONFIGAC})
  string(REGEX REPLACE ${R} "\\1" k ${_S})
  string(REGEX REPLACE ${R} "\\2" v ${_S})
  set(SO_${k} ${v})
endforeach()
math(EXPR SO_current_minus_age "${SO_current} - ${SO_age}")
set(SO_VER "${SO_current_minus_age}")
set(FULL_VER "${SO_current_minus_age}.${SO_revision}.${SO_age}")

# Read package version info from configure.ac
set(R "AC_INIT\\(RtAudio, ([0-9\\.]+),.*\\)")
file(STRINGS "${CMAKE_CURRENT_SOURCE_DIR}/configure.ac" CONFIGAC
  REGEX "${R}")
string(REGEX REPLACE "${R}" "\\1" PACKAGE_VERSION "${CONFIGAC}")

# Init variables
set(rtaudio_SOURCES RtAudio.cpp RtAudio.h rtaudio_c.cpp rtaudio_c.h)
set(LINKLIBS)
set(PKGCONFIG_REQUIRES)
set(API_DEFS)
set(API_LIST)

# Tweak API-specific configuration.

# Jack
if (RTAUDIO_API_JACK AND jack_FOUND)
  set(NEED_PTHREAD ON)
  list(APPEND PKGCONFIG_REQUIRES "jack")
  list(APPEND API_DEFS "-D__UNIX_JACK__")
  list(APPEND API_LIST "jack")
  if(jack_FOUND)
    list(APPEND LINKLIBS ${jack_LIBRARIES})
    list(APPEND INCDIRS ${jack_INCLUDEDIR})
  else()
    list(APPEND LINKLIBS ${JACK_LIB})
  endif()
endif()

# ALSA
if (RTAUDIO_API_ALSA)
  set(NEED_PTHREAD ON)
  find_package(ALSA)
  if (NOT ALSA_FOUND)
    message(FATAL_ERROR "ALSA API requested but no ALSA dev libraries found")
  endif()
  list(APPEND INCDIRS ${ALSA_INCLUDE_DIR})
  list(APPEND LINKLIBS ${ALSA_LIBRARY})
  list(APPEND PKGCONFIG_REQUIRES "alsa")
  list(APPEND API_DEFS "-D__LINUX_ALSA__")
  list(APPEND API_LIST "alsa")
endif()

# OSS
if (RTAUDIO_OSS)
  set(NEED_PTHREAD ON)
  find_library(OSSAUDIO_LIB ossaudio)
  if (OSSAUDIO_LIB)
    list(APPEND LINKLIBS ossaudio)
    # Note: not an error on some systems
  endif()
  list(APPEND API_DEFS "-D__LINUX_OSS__")
  list(APPEND API_LIST "oss")
endif()

# Pulse
if (RTAUDIO_API_PULSE)
  set(NEED_PTHREAD ON)
  find_library(PULSE_LIB pulse)
  find_library(PULSESIMPLE_LIB pulse-simple)
  list(APPEND LINKLIBS ${PULSE_LIB} ${PULSESIMPLE_LIB})
  list(APPEND PKGCONFIG_REQUIRES "libpulse-simple")
  list(APPEND API_DEFS "-D__LINUX_PULSE__")
  list(APPEND API_LIST "pulse")
endif()

# CoreAudio
if (RTAUDIO_API_CORE)
  find_library(COREAUDIO_LIB CoreAudio)
  find_library(COREFOUNDATION_LIB CoreFoundation)
  list(APPEND LINKLIBS ${COREAUDIO_LIB} ${COREFOUNDATION_LIB})
  list(APPEND API_DEFS "-D__MACOSX_CORE__")
  list(APPEND API_LIST "core")
endif()

# ASIO
if (RTAUDIO_API_ASIO)
  set(NEED_WIN32LIBS ON)
  include_directories(include)
  list(APPEND rtaudio_SOURCES
    include/asio.cpp
    include/asiodrivers.cpp
    include/asiolist.cpp
    include/iasiothiscallresolver.cpp)
  list(APPEND API_DEFS "-D__WINDOWS_ASIO__")
  list(APPEND API_LIST "asio")
endif()

# DSound
if (RTAUDIO_API_DS)
  set(NEED_WIN32LIBS ON)
  list(APPEND LINKLIBS dsound)
  list(APPEND API_DEFS "-D__WINDOWS_DS__")
  list(APPEND API_LIST "ds")
endif()

# WASAPI
if (RTAUDIO_API_WASAPI)
  include_directories(include)
  set(NEED_WIN32LIBS ON)
  list(APPEND LINKLIBS ksuser mfplat mfuuid wmcodecdspuuid)
  list(APPEND API_DEFS "-D__WINDOWS_WASAPI__")
  list(APPEND API_LIST "wasapi")
endif()

# Windows libs
if (NEED_WIN32LIBS)
  list(APPEND LINKLIBS winmm ole32)
endif()

# pthread
if (NEED_PTHREAD)
  find_package(Threads REQUIRED
    CMAKE_THREAD_PREFER_PTHREAD
    THREADS_PREFER_PTHREAD_FLAG)
  list(APPEND LINKLIBS Threads::Threads)
endif()

# Create library targets.
set(LIB_TARGETS)

# Use RTAUDIO_BUILD_SHARED_LIBS / RTAUDIO_BUILD_STATIC_LIBS if they
# are defined, otherwise default to standard BUILD_SHARED_LIBS.
if (DEFINED RTAUDIO_BUILD_SHARED_LIBS)
  if (RTAUDIO_BUILD_SHARED_LIBS)
    add_library(rtaudio SHARED ${rtaudio_SOURCES})
  else()
    add_library(rtaudio STATIC ${rtaudio_SOURCES})
    set(RTAUDIO_IS_STATIC TRUE)
  endif()
elseif (DEFINED RTAUDIO_BUILD_STATIC_LIBS)
  if (RTAUDIO_BUILD_STATIC_LIBS)
    add_library(rtaudio STATIC ${rtaudio_SOURCES})
    set(RTAUDIO_IS_STATIC TRUE)
  else()
    add_library(rtaudio SHARED ${rtaudio_SOURCES})
  endif()
else()
  add_library(rtaudio ${rtaudio_SOURCES})
  if(NOT BUILD_SHARED_LIBS)
    set(RTAUDIO_IS_STATIC TRUE)
  endif()
endif()
list(APPEND LIB_TARGETS rtaudio)

if (NOT DEFINED RTAUDIO_STATIC_MSVCRT)
  set(RTAUDIO_STATIC_MSVCRT ${RTAUDIO_IS_STATIC})
endif()

# In MSVC, set MD/MT appropriately for a static library
# (From https://github.com/protocolbuffers/protobuf/blob/master/cmake/CMakeLists.txt)
if(MSVC AND RTAUDIO_STATIC_MSVCRT)
  foreach(flag_var
      CMAKE_CXX_FLAGS CMAKE_CXX_FLAGS_DEBUG CMAKE_CXX_FLAGS_RELEASE
      CMAKE_CXX_FLAGS_MINSIZEREL CMAKE_CXX_FLAGS_RELWITHDEBINFO)
    if(${flag_var} MATCHES "/MD")
      string(REGEX REPLACE "/MD" "/MT" ${flag_var} "${${flag_var}}")
    endif(${flag_var} MATCHES "/MD")
  endforeach(flag_var)
endif()

# Add headers destination for install rule.
set_property(TARGET rtaudio PROPERTY PUBLIC_HEADER RtAudio.h rtaudio_c.h)
set_target_properties(rtaudio PROPERTIES
  SOVERSION ${SO_VER}
  VERSION ${FULL_VER})

# Set standard installation directories.
include(GNUInstallDirs)

# Set include paths, populate target interface.
target_include_directories(rtaudio
  INTERFACE
    $<INSTALL_INTERFACE:${CMAKE_INSTALL_INCLUDEDIR}/rtaudio>
  PRIVATE
    $<BUILD_INTERFACE:${CMAKE_CURRENT_SOURCE_DIR}>
    ${INCDIRS}
)

# Set compile-time definitions
target_compile_definitions(rtaudio PRIVATE ${API_DEFS})
target_compile_definitions(rtaudio PRIVATE RTAUDIO_EXPORT)
target_link_libraries(rtaudio ${LINKLIBS})

# Subdirs
include(CTest)

if (NOT DEFINED RTAUDIO_BUILD_TESTING OR RTAUDIO_BUILD_TESTING STREQUAL "")
  set(RTAUDIO_BUILD_TESTING ${BUILD_TESTING})
endif()
if (RTAUDIO_BUILD_TESTING)
  add_subdirectory(tests)
endif()

# Message
string(REPLACE ";" " " apilist "${API_LIST}")
message(STATUS "Compiling with support for: ${apilist}")

# PkgConfig file
string(REPLACE ";" " " req "${PKGCONFIG_REQUIRES}")
string(REPLACE ";" " " api "${API_DEFS}")
set(prefix ${CMAKE_INSTALL_PREFIX})
configure_file("${CMAKE_CURRENT_SOURCE_DIR}/rtaudio.pc.in" "rtaudio.pc" @ONLY)

# Add install rule.
install(TARGETS ${LIB_TARGETS}
        EXPORT RtAudioTargets
        LIBRARY DESTINATION ${CMAKE_INSTALL_LIBDIR}
        ARCHIVE DESTINATION ${CMAKE_INSTALL_LIBDIR}
        RUNTIME DESTINATION ${CMAKE_INSTALL_BINDIR}
        PUBLIC_HEADER DESTINATION ${CMAKE_INSTALL_INCLUDEDIR}/rtaudio)

# Store the package in the user registry.
export(PACKAGE RtAudio)

# Set installation path for CMake files.
set(RTAUDIO_CMAKE_DESTINATION share/rtaudio)

# Create CMake configuration export file.
file(WRITE ${CMAKE_CURRENT_BINARY_DIR}/RtAudioConfig.cmake.in "@PACKAGE_INIT@\n")

if(NEED_PTHREAD)
  file(APPEND ${CMAKE_CURRENT_BINARY_DIR}/RtAudioConfig.cmake.in "find_package(Threads REQUIRED)\n")
endif()

file(APPEND ${CMAKE_CURRENT_BINARY_DIR}/RtAudioConfig.cmake.in "include(\${CMAKE_CURRENT_LIST_DIR}/RtAudioTargets.cmake)")

# Install CMake configuration export file.
include(CMakePackageConfigHelpers)
configure_package_config_file(
  ${CMAKE_CURRENT_BINARY_DIR}/RtAudioConfig.cmake.in
  ${CMAKE_CURRENT_BINARY_DIR}/RtAudioConfig.cmake
  INSTALL_DESTINATION ${RTAUDIO_CMAKE_DESTINATION}
)

write_basic_package_version_file(
    ${CMAKE_CURRENT_BINARY_DIR}/RtAudioConfig-version.cmake
    VERSION ${FULL_VER}
    COMPATIBILITY AnyNewerVersion
)

install(
  FILES
    ${CMAKE_BINARY_DIR}/RtAudioConfig.cmake
    ${CMAKE_BINARY_DIR}/RtAudioConfig-version.cmake
  DESTINATION
    ${RTAUDIO_CMAKE_DESTINATION}
)

# Export library target (build-tree).
export(EXPORT RtAudioTargets
       NAMESPACE RtAudio::)

# Export library target (install-tree).
install(EXPORT RtAudioTargets
        DESTINATION ${RTAUDIO_CMAKE_DESTINATION}
        NAMESPACE RtAudio::)

# Configure uninstall target.
configure_file(
    "${CMAKE_CURRENT_SOURCE_DIR}/cmake/RtAudioConfigUninstall.cmake.in"
    "${CMAKE_CURRENT_BINARY_DIR}/RtAudioConfigUninstall.cmake" @ONLY)

# Create uninstall target.
add_custom_target(${RTAUDIO_TARGETNAME_UNINSTALL}
    COMMAND ${CMAKE_COMMAND} -P ${CMAKE_CURRENT_BINARY_DIR}/RtAudioConfigUninstall.cmake)

install(
    FILES ${CMAKE_CURRENT_BINARY_DIR}/rtaudio.pc
    DESTINATION ${CMAKE_INSTALL_LIBDIR}/pkgconfig)

=== src/deps/vst3sdk/CMakeLists.txt ===

cmake_minimum_required (VERSION 3.4.3)

#-------------------------------------------------------------------------------
# Includes
#-------------------------------------------------------------------------------

list(APPEND CMAKE_MODULE_PATH "${CMAKE_CURRENT_SOURCE_DIR}/cmake/modules")

include(SMTG_VST3_SDK)

#-------------------------------------------------------------------------------
# SDK Project
#-------------------------------------------------------------------------------
project(vstsdk)

setupPlatformToolset()

set(ROOT "${CMAKE_CURRENT_SOURCE_DIR}")

# Here you can define where the VST 3 SDK is located
set(SDK_ROOT "${ROOT}")
set(public_sdk_SOURCE_DIR ${SDK_ROOT}/public.sdk)
set(pluginterfaces_SOURCE_DIR ${SDK_ROOT}/pluginterfaces)

# Here you can define where the VSTGUI is located
if(SMTG_ADD_VSTGUI)
    set(VSTGUI_ROOT "${ROOT}")
    setupVstGuiSupport()
endif()

include_directories(${ROOT} ${SDK_ROOT})

#-------------------------------------------------------------------------------
# From Here this is optional...

#-------------------------------------------------------------------------------
# CORE AUDIO SDK, AAX SDK
#-------------------------------------------------------------------------------
setupCoreAudioSupport()
setupAaxSupport()


#-------------------------------------------------------------------------------
# Projects
#-------------------------------------------------------------------------------
set(SDK_IDE_LIBS_FOLDER FOLDER "Libraries")

#---Add base libraries---------------------------
set(VST_SDK TRUE) # used for Base module which provides only a subset of Base for VST-SDK
add_subdirectory(pluginterfaces)
add_subdirectory(base)
add_subdirectory(public.sdk)
add_subdirectory(public.sdk/source/vst/interappaudio)

#---Add Wrappers (AU, AAX)-----------------------
if (SMTG_COREAUDIO_SDK_PATH)
    add_subdirectory(public.sdk/source/vst/auwrapper)
endif()

if(SMTG_AAX_SDK_PATH)
    add_subdirectory(public.sdk/source/vst/aaxwrapper)
    set_target_properties(aaxwrapper PROPERTIES ${SDK_IDE_LIBS_FOLDER})
endif()

#-------------------------------------------------------------------------------
# Here is added your own plugins folder location
#-------------------------------------------------------------------------------
set(SDK_IDE_MYPLUGINS_FOLDER FOLDER "MyPlugIns")
if(EXISTS ${SMTG_MYPLUGINS_SRC_PATH})
    set(SMTG_MYPLUGINS_BIN_PATH "${SMTG_MYPLUGINS_SRC_PATH}/build")
    add_subdirectory(${SMTG_MYPLUGINS_SRC_PATH} ${SMTG_MYPLUGINS_BIN_PATH})
endif()


#---Add VST3 examples (plug-ins and hosting)-----
if(SMTG_ADD_VST3_PLUGINS_SAMPLES)
    set(SDK_IDE_PLUGIN_EXAMPLES_FOLDER FOLDER "PlugInExamples")
    add_subdirectory(public.sdk/samples/vst)
    add_subdirectory(public.sdk/source/vst/auwrapper/again)
    add_subdirectory(public.sdk/source/vst/auv3wrapper)
endif()

# Add hosting examples, it includes the validator
set(SDK_IDE_HOSTING_EXAMPLES_FOLDER FOLDER "HostingExamples")
add_subdirectory(public.sdk/samples/vst-hosting)

#-------------------------------------------------------------------------------
# IDE sorting
#-------------------------------------------------------------------------------
set_target_properties(sdk PROPERTIES ${SDK_IDE_LIBS_FOLDER})
set_target_properties(base PROPERTIES ${SDK_IDE_LIBS_FOLDER})
set_target_properties(pluginterfaces PROPERTIES ${SDK_IDE_LIBS_FOLDER})
if(TARGET base_ios)
    set_target_properties(base_ios PROPERTIES ${SDK_IDE_LIBS_FOLDER})
    set_target_properties(pluginterfaces_ios PROPERTIES ${SDK_IDE_LIBS_FOLDER})
endif()

if(SMTG_ADD_VSTGUI)
    set_target_properties(vstgui PROPERTIES ${SDK_IDE_LIBS_FOLDER})
    set_target_properties(vstgui_support PROPERTIES ${SDK_IDE_LIBS_FOLDER})
    set_target_properties(vstgui_uidescription PROPERTIES ${SDK_IDE_LIBS_FOLDER})

    if(TARGET vstgui_standalone)
        set_target_properties(vstgui_standalone PROPERTIES ${SDK_IDE_LIBS_FOLDER})
    endif()
endif()

=== src/deps/vst3sdk/base/CMakeLists.txt ===

cmake_minimum_required(VERSION 3.4.3)

project(smtg_base)

add_library(base STATIC
    source/baseiids.cpp
    source/classfactoryhelpers.h
    source/fbuffer.cpp
    source/fbuffer.h
    source/fcleanup.h
    source/fcommandline.h
    source/fdebug.cpp
    source/fdebug.h
    source/fdynlib.cpp
    source/fdynlib.h
    source/fobject.cpp
    source/fobject.h
    source/fstreamer.cpp
    source/fstreamer.h
    source/fstring.cpp
    source/fstring.h
    source/timer.cpp
    source/timer.h
    source/updatehandler.cpp
    source/updatehandler.h
    thread/include/fcondition.h
    thread/include/flock.h
    thread/source/fcondition.cpp
    thread/source/flock.cpp
)

# Additional sources for other usage
if(FULL_BASE)
    target_sources(base PRIVATE
        source/basefwd.h
        source/classfactory.cpp
        source/classfactory.h
        source/fbitset.cpp
        source/fbitset.h
        source/fcontainer.h
        source/fcpu.cpp
        source/fcpu.h
        source/fcriticalperformance.cpp
        source/fcriticalperformance.h
        source/finitializer.cpp
        source/finitializer.h
        source/fmemory.cpp
        source/fmemory.h
        source/fpoint.cpp
        source/fpoint.h
        source/frect.cpp
        source/frect.h
        source/fregion.cpp
        source/fregion.h
        source/fstdmethods.h
        source/fstringmethods.h
        source/fstringstream.h
        source/funknownfactory.h
        source/hexbinary.h
        source/istreamwrapper.cpp
        source/istreamwrapper.h
        source/tringbuffer.h    
        thread/include/fatomic.h
        thread/include/forwarddeclarations.h
        thread/include/frwlock_generic.h
        thread/include/frwlock_macosx.h
        thread/include/frwlock_windows.h
        thread/include/fthread.h
        thread/source/fatomic.cpp
        thread/source/fthread.cpp
    )
endif()

target_include_directories(base
    PUBLIC
        ${CMAKE_CURRENT_SOURCE_DIR}/..
)

if(MSVC)
    set(CMAKE_STATIC_LINKER_FLAGS "${CMAKE_STATIC_LINKER_FLAGS} /IGNORE:4221")
endif()

smtg_setup_universal_binary(base)

# iOS target
if(SMTG_MAC AND XCODE AND SMTG_IOS_DEVELOPMENT_TEAM)
    get_target_property(BASE_SOURCES base SOURCES)
    add_library(base_ios STATIC ${BASE_SOURCES})
    smtg_set_platform_ios(base_ios)
endif()

=== src/deps/vst3sdk/pluginterfaces/CMakeLists.txt ===

# pluginterfaces should actually be a header-only library,
# but it has some sources as well which need compilation.

cmake_minimum_required(VERSION 3.4.3)

project(smtg_pluginterfaces)

# base interfaces
add_library(pluginterfaces STATIC
    base/conststringtable.cpp
    base/conststringtable.h
    base/coreiids.cpp
    base/falignpop.h
    base/falignpush.h
    base/fplatform.h
    base/fstrdefs.h
    base/ftypes.h
    base/funknown.cpp
    base/funknown.h
    base/futils.h
    base/fvariant.h
    base/geoconstants.h
    base/ibstream.h
    base/icloneable.h
    base/ierrorcontext.h
    base/ipersistent.h
    base/ipluginbase.h
    base/istringresult.h
    base/iupdatehandler.h
    base/keycodes.h
    base/pluginbasefwd.h
    base/smartpointer.h
    base/typesizecheck.h
    base/ucolorspec.h
    base/ustring.cpp
    base/ustring.h
)

# vst3 interfaces
if (VST_SDK)
    target_sources(pluginterfaces PRIVATE
        gui/iplugview.h
        gui/iplugviewcontentscalesupport.h
        vst/ivstattributes.h
        vst/ivstaudioprocessor.h
        vst/ivstautomationstate.h
        vst/ivstchannelcontextinfo.h
        vst/ivstcomponent.h
        vst/ivstcontextmenu.h
        vst/ivsteditcontroller.h
        vst/ivstevents.h
        vst/ivsthostapplication.h
        vst/ivstinterappaudio.h
        vst/ivstmessage.h
        vst/ivstmidicontrollers.h
        vst/ivstmidilearn.h
        vst/ivstnoteexpression.h
        vst/ivstparameterchanges.h
        vst/ivstparameterfunctionname.h
        vst/ivstphysicalui.h
        vst/ivstpluginterfacesupport.h
        vst/ivstplugview.h
        vst/ivstprefetchablesupport.h
        vst/ivstprocesscontext.h
        vst/ivstrepresentation.h
        vst/ivstunits.h
        vst/vstpresetkeys.h
        vst/vstpshpack4.h
        vst/vstspeaker.h
        vst/vsttypes.h
)
endif()

# ski interfaces
if (SKI_SDK)
    target_sources(pluginterfaces PRIVATE
        host/paramids.cpp 
        host/paramids.h
)
endif()

target_include_directories(pluginterfaces PUBLIC
    ${CMAKE_CURRENT_SOURCE_DIR}/..
)

smtg_setup_universal_binary(pluginterfaces)

# iOS target
if(SMTG_MAC AND XCODE AND SMTG_IOS_DEVELOPMENT_TEAM)
	get_target_property(PLUGINTERFACES_SOURCES pluginterfaces SOURCES)
	add_library(pluginterfaces_ios STATIC ${PLUGINTERFACES_SOURCES})
	smtg_set_platform_ios(pluginterfaces_ios)
endif()

=== src/deps/vst3sdk/public.sdk/CMakeLists.txt ===

cmake_minimum_required(VERSION 3.4.3)

project(smtg_public_sdk)

add_library(sdk STATIC 
    source/common/commoniids.cpp
    source/common/openurl.cpp
    source/common/openurl.h
    source/common/pluginview.cpp
    source/common/pluginview.h
    source/common/threadchecker_linux.cpp
    source/common/threadchecker_win32.cpp
    source/common/threadchecker.h
    source/main/pluginfactory.cpp
    source/main/pluginfactory.h
)
if(SMTG_MAC)
    target_sources(sdk PRIVATE
        source/common/threadchecker_mac.mm
    )
endif()

if(NOT VST_SDK)
    target_sources(sdk PRIVATE
        source/common/pvaluecontainer.cpp
        source/common/pvaluecontainer.h
    )
endif()

# Additional sources for VST3 SDK usage
if(VST_SDK)
    target_sources(sdk PRIVATE
        source/vst/utility/processcontextrequirements.h
        source/vst/utility/ringbuffer.h
        source/vst/utility/vst2persistence.h
        source/vst/utility/vst2persistence.cpp
        source/vst/vstaudioeffect.cpp
        source/vst/vstaudioeffect.h
        source/vst/vstbus.cpp
        source/vst/vstbus.h
        source/vst/vstbypassprocessor.h
        source/vst/vstcomponent.cpp
        source/vst/vstcomponent.h
        source/vst/vstcomponentbase.cpp
        source/vst/vstcomponentbase.h
        source/vst/vsteditcontroller.cpp
        source/vst/vsteditcontroller.h
        source/vst/vsteventshelper.h
        source/vst/vsthelpers.h
        source/vst/vstinitiids.cpp
        source/vst/vstnoteexpressiontypes.cpp
        source/vst/vstnoteexpressiontypes.h
        source/vst/vstparameters.cpp
        source/vst/vstparameters.h
        source/vst/vstpresetfile.cpp
        source/vst/vstpresetfile.h
        source/vst/vstrepresentation.cpp
        source/vst/vstrepresentation.h
    )
endif()

target_link_libraries(sdk PRIVATE 
    base
    pluginterfaces
)

smtg_setup_universal_binary(sdk)

get_target_property(sdk_SOURCES sdk SOURCES)
source_group("public.sdk"   FILES ${sdk_SOURCES})

# iOS target
if(SMTG_MAC AND XCODE AND SMTG_IOS_DEVELOPMENT_TEAM)
    add_library(sdk_ios STATIC 
        ${sdk_SOURCES}
    )
    smtg_set_platform_ios(sdk_ios)
    set_target_properties(sdk_ios PROPERTIES ${SDK_IDE_LIBS_FOLDER})
    target_link_libraries(sdk_ios PRIVATE 
        base_ios
        pluginterfaces_ios
    )
endif()

=== src/deps/vst3sdk/public.sdk/source/vst/aaxwrapper/CMakeLists.txt ===

set(target aaxwrapper)
set(${target}_sources
    ${SDK_ROOT}/public.sdk/source/vst/basewrapper/basewrapper.sdk.cpp
    aaxentry.cpp
    aaxlibrary.cpp
    aaxwrapper.cpp
    aaxwrapper.h
    aaxwrapper_description.h
    aaxwrapper_gui.cpp
    aaxwrapper_gui.h
    aaxwrapper_parameters.cpp
    aaxwrapper_parameters.h
    docaax.h
    resource/PlugIn.ico
)
add_library(${target} STATIC ${${target}_sources})

target_include_directories(${target} PRIVATE "${SMTG_AAX_SDK_PATH}/Interfaces")
target_include_directories(${target} PRIVATE "${SMTG_AAX_SDK_PATH}/Interfaces/ACF")
target_include_directories(${target} PRIVATE "${SMTG_AAX_SDK_PATH}/Libs/AAXLibrary/Include")
smtg_setup_universal_binary(${target})

if(XCODE)
    add_compile_options(-Wno-incompatible-ms-struct)
elseif(SMTG_WIN)
    add_compile_options(/wd4996)
    add_compile_options(/GR)
    # too much warnings in the AAX SDK!!
add_definitions(-D_CRT_SECURE_NO_WARNINGS)
endif()

=== src/deps/vst3sdk/public.sdk/source/vst/auv3wrapper/CMakeLists.txt ===
include(AddVST3AuV3)

# iOS target
if(SMTG_MAC)
    if(XCODE AND SMTG_IOS_DEVELOPMENT_TEAM)
        
        set(auv3wrapperlib_sources
            ${SDK_ROOT}/public.sdk/source/vst/auv3wrapper/Shared/AUv3Wrapper.mm
            ${SDK_ROOT}/public.sdk/source/vst/auv3wrapper/Shared/AUv3Wrapper.h
            ${SDK_ROOT}/public.sdk/source/vst/auv3wrapper/Shared/AUv3AudioEngine.mm
            ${SDK_ROOT}/public.sdk/source/vst/auv3wrapper/Shared/AUv3AudioEngine.h
            ${SDK_ROOT}/public.sdk/source/vst/auwrapper/NSDataIBStream.mm
            ${SDK_ROOT}/public.sdk/source/vst/auwrapper/NSDataIBStream.h
            ${SDK_ROOT}/public.sdk/source/vst/hosting/eventlist.cpp
            ${SDK_ROOT}/public.sdk/source/vst/hosting/hostclasses.cpp
            ${SDK_ROOT}/public.sdk/source/vst/hosting/hostclasses.h
            ${SDK_ROOT}/public.sdk/source/vst/hosting/parameterchanges.cpp
            ${SDK_ROOT}/public.sdk/source/vst/hosting/parameterchanges.h
            ${SDK_ROOT}/public.sdk/source/vst/hosting/pluginterfacesupport.cpp
            ${SDK_ROOT}/public.sdk/source/vst/hosting/pluginterfacesupport.h
            ${SDK_ROOT}/public.sdk/source/vst/hosting/processdata.cpp
            ${SDK_ROOT}/public.sdk/source/vst/hosting/processdata.h
            ${SDK_ROOT}/public.sdk/source/vst/utility/mpeprocessor.cpp
            ${SDK_ROOT}/public.sdk/source/vst/utility/mpeprocessor.h
        )

        #--------------------------------------------------------------------------------------------------------
        set(target auv3wrappermacos)
        add_library(${target} STATIC ${auv3wrapperlib_sources})
        set_target_properties(${target} PROPERTIES ${SDK_IDE_LIBS_FOLDER} XCODE_ATTRIBUTE_CLANG_ENABLE_OBJC_ARC YES)
        target_link_libraries(${target} PRIVATE base sdk)
        if (SMTG_AUV3_WRAPPER_EXTERNAL_PLUGIN_FACTORY)
            target_compile_definitions(${target} PRIVATE SMTG_AUV3_WRAPPER_EXTERNAL_PLUGIN_FACTORY=1)
        endif()

        #--------------------------------------------------------------------------------------------------------
        set(target auv3wrapperios)
        add_library(${target} STATIC ${auv3wrapperlib_sources})
        set_target_properties(${target} PROPERTIES ${SDK_IDE_LIBS_FOLDER} XCODE_ATTRIBUTE_CLANG_ENABLE_OBJC_ARC YES)
        set_target_properties(${target} PROPERTIES LINK_FLAGS "-Wl,-F/Library/Frameworks")
        smtg_set_platform_ios(${target})
        target_link_libraries(${target} PRIVATE base_ios sdk_ios)
        if (SMTG_AUV3_WRAPPER_EXTERNAL_PLUGIN_FACTORY)
            target_compile_definitions(${target} PRIVATE SMTG_AUV3_WRAPPER_EXTERNAL_PLUGIN_FACTORY=1)
        endif()
    else()
        message("* To enable building the AUv3 Wrapper example for iOS you need to set the SMTG_IOS_DEVELOPMENT_TEAM and use the Xcode generator")
    endif()
endif()

=== src/deps/vst3sdk/public.sdk/source/vst/auwrapper/CMakeLists.txt ===
if(SMTG_MAC)
    if (XCODE AND SMTG_COREAUDIO_SDK_PATH)
        set(target auwrapper)
        set(${target}_sources
            aucarbonview.mm
            aucarbonview.h
            aucocoaview.mm
            aucocoaview.h
            ausdk.mm
            auwrapper.mm
            auwrapper.h
            NSDataIBStream.mm
            NSDataIBStream.h
            ${SDK_ROOT}/pluginterfaces/base/funknown.cpp
            ${SDK_ROOT}/pluginterfaces/base/ustring.cpp
            ${SDK_ROOT}/pluginterfaces/base/coreiids.cpp
            ${SDK_ROOT}/public.sdk/source/vst/hosting/eventlist.cpp
            ${SDK_ROOT}/public.sdk/source/vst/hosting/eventlist.h
            ${SDK_ROOT}/public.sdk/source/vst/hosting/hostclasses.cpp
            ${SDK_ROOT}/public.sdk/source/vst/hosting/hostclasses.h
            ${SDK_ROOT}/public.sdk/source/vst/hosting/parameterchanges.cpp
            ${SDK_ROOT}/public.sdk/source/vst/hosting/parameterchanges.h
            ${SDK_ROOT}/public.sdk/source/vst/hosting/pluginterfacesupport.cpp
            ${SDK_ROOT}/public.sdk/source/vst/hosting/pluginterfacesupport.h
            ${SDK_ROOT}/public.sdk/source/vst/hosting/processdata.cpp
            ${SDK_ROOT}/public.sdk/source/vst/hosting/processdata.h
            ${SDK_ROOT}/public.sdk/source/vst/vstinitiids.cpp
        )
        add_library(${target} STATIC ${${target}_sources})
        smtg_setup_universal_binary(${target})
        set_target_properties(${target} PROPERTIES ${SDK_IDE_LIBS_FOLDER})
        target_link_libraries(${target} PRIVATE base "-framework AudioUnit" "-framework CoreMIDI" "-framework AudioToolbox" "-framework CoreFoundation" "-framework Carbon" "-framework Cocoa" "-framework CoreAudio")
        target_include_directories(${target} PRIVATE "${SMTG_COREAUDIO_SDK_PATH}/**")
        add_custom_command(TARGET ${target} PRE_BUILD COMMAND /usr/bin/ruby "./generateCocoaClassNamePrefix.rb" "${CMAKE_CURRENT_LIST_DIR}" WORKING_DIRECTORY "${CMAKE_CURRENT_LIST_DIR}")
    else()
        message("* To enable building the AudioUnit wrapper, you need to use the Xcode generator and set SMTG_COREAUDIO_SDK_PATH to the path of your installation of the CoreAudio SDK!")
    endif()
endif()

=== src/deps/vst3sdk/public.sdk/source/vst/interappaudio/CMakeLists.txt ===

if(SMTG_MAC)
    option(SMTG_BUILD_INTERAPPAUDIO "Enable building the iOS InterAppAudio examples (deprecated)" OFF)


    if(XCODE AND SMTG_IOS_DEVELOPMENT_TEAM AND SMTG_BUILD_INTERAPPAUDIO)

        message("****************************************************************************************************************************************")
        message("***** The iOS InterAppAudio wrapper is deprecated and may be removed in the next SDK update. Please switch to AudioUnit V3 on iOS. *****")
        message("****************************************************************************************************************************************")

        set(target interappaudio)
        
        set(${target}_sources
            AudioIO.mm
            AudioIO.h
            HostApp.mm
            HostApp.h
            MidiIO.mm
            MidiIO.h
            PresetBrowserViewController.mm
            PresetBrowserViewController.h
            PresetManager.mm
            PresetManager.h
            PresetSaveViewController.mm
            PresetSaveViewController.h
            SettingsViewController.mm
            SettingsViewController.h
            VST3Editor.mm
            VST3Editor.h
            VST3Plugin.mm
            VST3Plugin.h
            VSTInterAppAudioAppDelegateBase.mm
            VSTInterAppAudioAppDelegateBase.h
        )
        add_library(${target} STATIC ${${target}_sources})
        smtg_set_platform_ios(${target})
        set_target_properties(${target} PROPERTIES ${SDK_IDE_LIBS_FOLDER})
        target_link_libraries(${target} PRIVATE sdk_ios "-framework CoreGraphics" "-framework UIKit" "-framework CoreMIDI" "-framework AudioToolbox" "-framework AVFoundation")
    endif()
endif()

=== src/deps/vst3sdk/public.sdk/source/vst/auwrapper/again/CMakeLists.txt ===
if(SMTG_MAC AND XCODE AND SMTG_COREAUDIO_SDK_PATH AND SMTG_ADD_VSTGUI)
	# TODO: VST3_OUTPUT_DIR should be declared somewhere more globally.
	set(VST3_OUTPUT_DIR ${CMAKE_BINARY_DIR}/VST3)

    set(target again_au)
    set(${target}_sources
        doc.cpp
        audiounitconfig.h
        Info.plist
    )
    add_library(${target} MODULE ${${target}_sources})
    smtg_setup_universal_binary(${target})
    set_target_properties(${target} PROPERTIES ${SDK_IDE_PLUGIN_EXAMPLES_FOLDER})
    set_target_properties(${target} PROPERTIES BUNDLE TRUE)
    set_target_properties(${target} PROPERTIES XCODE_ATTRIBUTE_GENERATE_MASTER_OBJECT_FILE "YES")
    set_target_properties(${target} PROPERTIES XCODE_ATTRIBUTE_OTHER_LDFLAGS "-all_load")
    set_target_properties(${target} PROPERTIES XCODE_ATTRIBUTE_GENERATE_PKGINFO_FILE "YES")
    set_target_properties(${target} PROPERTIES XCODE_ATTRIBUTE_WRAPPER_EXTENSION "component")
    set_target_properties(${target} PROPERTIES LIBRARY_OUTPUT_DIRECTORY ${VST3_OUTPUT_DIR})
    target_link_libraries(${target} PRIVATE auwrapper)
    smtg_set_bundle(${target} INFOPLIST "${CMAKE_CURRENT_LIST_DIR}/Info.plist" PREPROCESS)

    set(outputdir ${VST3_OUTPUT_DIR}/$<CONFIG>)

    add_dependencies(${target} again)
    add_custom_command(TARGET ${target} POST_BUILD 
        COMMAND /bin/mkdir "-p" ${outputdir}/${target}.component/Contents/Resources
        COMMAND /bin/rm "-f" "${outputdir}/${target}.component/Contents/Resources/plugin.vst3"
        COMMAND /bin/ln "-svfF" "${outputdir}/again.vst3" "${outputdir}/${target}.component/Contents/Resources/plugin.vst3"
        COMMAND /bin/ln "-svfF" "${outputdir}/${target}.component" "~/Library/Audio/Plug-Ins/Components/"
    )

    execute_process(COMMAND xcrun --find Rez OUTPUT_VARIABLE OSX_REZ_COMMAND OUTPUT_STRIP_TRAILING_WHITESPACE)
    add_custom_command(TARGET ${target} POST_BUILD COMMAND "${OSX_REZ_COMMAND}"
        "-d" "SystemSevenOrLater=1"
        "-script" "Roman"
        "-d" "i386_YES"
        "-d" "x86_64_YES"
        "-is" "${CMAKE_OSX_SYSROOT}"
        "-I" "${CMAKE_OSX_SYSROOT}/System/Library/Frameworks/CoreServices.framework/Frameworks/CarbonCore.framework/Versions/A/Headers"
        "-I" "/System/Library/Frameworks/CoreServices.framework/Frameworks/CarbonCore.framework/Versions/A/Headers"
        "-I" "/System/Library/Frameworks/AudioUnit.framework/Versions/A/Headers/"
        "-I" "${SMTG_COREAUDIO_SDK_PATH}/AudioUnits/AUPublic/AUBase"
        "-I" "${CMAKE_CURRENT_LIST_DIR}"
        "-o" "${outputdir}/${target}.component/Contents/Resources/again_au.rsrc"
        "-useDF"
        "${CMAKE_CURRENT_LIST_DIR}/../auresource.r"
    )

endif()

=== PKGBUILD ===
# Maintainer: David Runge <dvzrv@archlinux.org>

pkgname=giada
pkgver=0.18.2
pkgrel=1
pkgdesc="A free, minimal, hardcore audio tool for DJs, live performers and electronic musicians"
arch=('x86_64')
url="https://www.giadamusic.com/"
license=('GPL3')
groups=('pro-audio')
depends=('gcc-libs' 'glibc' 'hicolor-icon-theme' 'libx11' 'libxcursor' 'libxft'
'libxinerama' 'libxpm')
# upstream vendors a hacked rtaudio :(
makedepends=('alsa-lib' 'catch2' 'cmake' 'fltk' 'gendesk' 'imagemagick' 'jack'
'libpulse' 'libsamplerate' 'libsndfile' 'libxrandr' 'nlohmann-json' 'rtmidi')
checkdepends=('xorg-server-xvfb')
provides=('vst3-host')
source=("https://www.giadamusic.com/data/${pkgname}-v${pkgver}-src.tar.gz"
        "$pkgname-0.17.2-devendor_nlohmann_json.patch")
sha512sums=('205b27ecbc8c2fef87908a6f0c2c532c1199fba94e4c65d7ba48c07d022c50b30c180a58860b117977e0089ad26e19adee645a06ce42586a8f7ef2ad93166d23'
            'b9d952c0816dd2b81dadff24521b19f305ca5ddeb1964dd81ce93e6f63b25dbf291c07e528cc2836f268a095bf9920786331a615230416f44a9014ff581a0bce')
b2sums=('0a59f68ae2641d7e62d98fc18d7ec9cf18164cf7510f0a3c9558f419ee19b39bcedf7fdc1349dbda055d8d36c8f8d61d31cfe363bccb511996af9ba5c3f0691c'
        'a482f356969c5d184a1eb0945477040cc7c5d1447fee0159cc5d2da05faea0bd696123b0559bdced148b301181f93726a515df24a814dbd08d207e2959f31305')

prepare() {
  mv -v "$pkgname-$pkgver-src" "$pkgname-$pkgver"
  cd "$pkgname-$pkgver"
  # XDG desktop file
  gendesk -n \
          --pkgname ${pkgname} \
          --pkgdesc "${pkgdesc}" \
          --name Giada \
          --categories "AudioVideo;Audio;Midi;Sequencer"

  # devendor nlohmann-json
  patch -Np1 -i ../"$pkgname-0.17.2-devendor_nlohmann_json.patch"
}

build() {
  cd "$pkgname-$pkgver"
  cmake -DCMAKE_INSTALL_PREFIX=/usr \
        -DCMAKE_BUILD_TYPE='None' \
        -DWITH_VST3=ON \
        -W no-dev \
        -B build \
        -S .
  cmake -DCMAKE_INSTALL_PREFIX=/usr \
        -DCMAKE_BUILD_TYPE='None' \
        -DWITH_VST3=ON \
        -DWITH_TESTS=ON \
        -W no-dev \
        -B build-test \
        -S .
  make VERBOSE=1 -C build
  make VERBOSE=1 -C build-test
}

check(){
  cd "$pkgname-$pkgver"
  xvfb-run ./build-test/giada --run-tests
}

package() {
  depends+=('libasound.so' 'libfreetype.so' 'libjack.so' 'libpulse.so'
  'libpulse-simple.so' 'librtmidi.so' 'libsamplerate.so' 'libsndfile.so')
  cd "$pkgname-$pkgver"
  make DESTDIR="$pkgdir/" install -C build
  # docs
  install -vDm 644 {ChangeLog,README.md} \
    -t "${pkgdir}/usr/share/doc/${pkgname}"
}
